#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n,k;
    cin >> n >> k;
    string s,l;
    cin >> s;
    l = s;
    map<char,int> c;
    string x = "abcdefghijklmnopqrstuvwxyz";
    sort(l.begin(),l.end());
    if(l == s){
        cout << 1 << ' ';
        for(int i = 1;i < n;i++){
            c[s[i]]++;
            int mn = 200005;
            for(int j = 0;j < k;j++){
                mn = min(c[x[j]],mn);
            }
            if(mn == 0 && i != n-1) cout << 1 << ' ';
            else cout << 2 << ' ';
        }
    }
    else{
        for(int i = 0;i < n;i++){
            c[s[i]]++;
            int mn = 200005;
            for(int j = 0;j < k;j++){
                mn = min(c[x[j]],mn);
            }
            cout << mn+1 << ' ';
        }
    }

    return 0;
}